package zclystal.common.core;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.config.Configuration;
import zclystal.common.event.LivingEventHooks;
import zclystal.common.item.ItemZCrystal;
import cpw.mods.fml.common.FMLLog;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.registry.GameRegistry;

@Mod(modid = "ZCrystal", name = "Z Crystal")
public class ZCrystalCore {

	//Z Crystalの定義
	public static Item crystalZ;

	public static boolean canfly = false;
	public static boolean isHard;
	private int damage;

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {

		//configの設定
		Configuration cfg = new Configuration(event.getSuggestedConfigurationFile());

		try {
			cfg.load();
			isHard = cfg.get("DIFFICULTY", "isHard", false).getBoolean(false);
		} catch (Exception error) {
			FMLLog.severe("Config Error");
		} finally {
			cfg.save();
		}

		MinecraftForge.EVENT_BUS.register(new LivingEventHooks());

		if (isHard) {
			damage = 1000;
		} else {
			damage = 5000;
		}

		//アイテムの設定
		crystalZ = new ItemZCrystal()
			.setCreativeTab(CreativeTabs.tabMisc)
			.setUnlocalizedName("crystalZ")
			.setTextureName("zcrystal:z_crystal")
			.setMaxDamage(damage)
			.setHasSubtypes(false)
			.setMaxStackSize(1);
		GameRegistry.registerItem(crystalZ, "crystalZ");

	}

	@EventHandler
	public void Init (FMLInitializationEvent event) {
		//レシピの追加
		GameRegistry.addRecipe(new ItemStack(crystalZ),
				"ZYZ", "YXY", "ZYZ", 'X', Items.diamond, 'Y', Items.gold_ingot, 'Z', Items.iron_ingot);
	}

}
