package zclystal.common.event;

import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.potion.Potion;
import net.minecraftforge.event.entity.living.LivingEvent.LivingUpdateEvent;
import net.minecraftforge.event.entity.living.LivingFallEvent;
import zclystal.common.core.ZCrystalCore;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;

public class LivingEventHooks {

	private boolean allowLevitatiton = false;//飛べるかどうか
	private boolean isLevitation = false;//飛んでいるかどうか
	private int flyToggleTimer = 0;//Jumpキーの入力間隔
	private int sprintToggleTimer = 0;//ダッシュの入力間隔
	private InventoryPlayer inventory;

	//アップデート時に呼ばれる
	@SubscribeEvent
	public void LivingUpdate(LivingUpdateEvent event) {
		if(event.entityLiving != null && event.entityLiving instanceof EntityPlayer && event.entityLiving .worldObj.isRemote) {
			EntityPlayerSP player = (EntityPlayerSP) event.entityLiving;
			Flight(player);
		}
	}

	//落下時ダメージ無効化処理
	@SubscribeEvent
	public void onPlayerFall(LivingFallEvent event) {
		if (event.entityLiving instanceof EntityPlayer) {
			EntityPlayer player = (EntityPlayer)event.entityLiving;
			if (this.allowLevitatiton) {
				event.setCanceled(true);
			}
		}
	}

	public void Flight(EntityPlayerSP player) {

		//飛べる状態かどうかの判定。
		this.allowLevitatiton = ZCrystalCore.canfly;

		//クリエイティブモードならとべるように
		if (player.capabilities.isCreativeMode) {
			this.allowLevitatiton = true;
		}

		//飛行が許可されていない状況では落ちるように
		if(!this.allowLevitatiton) {
			this.isLevitation = false;
		}

		boolean jump = ((EntityPlayerSP)player).movementInput.jump;//ジャンプ入力があるか
		float var2 = 0.8F;//ダッシュのための変数
		boolean var3 = ((EntityPlayerSP)player).movementInput.moveForward >= var2;//一定距離以上前に進んだか．ダッシュ用
		((EntityPlayerSP)player).movementInput.updatePlayerMoveState();//入力ステートを更新

		//Jumpキーを押して離したかどうか
		if (this.allowLevitatiton && !jump && ((EntityPlayerSP)player).movementInput.jump) {

			//Jumpキー入力1回目
			if (this.flyToggleTimer == 0) {
				this.flyToggleTimer = 7;//入力間隔のタイマー：7tick
			} else {
				//2回目
				this.isLevitation = !this.isLevitation;//飛行モードのトグル
				this.flyToggleTimer = 0;
			}

		}

		//ここからダッシュ関係
		boolean var4 = (float)((EntityPlayerSP)player).getFoodStats().getFoodLevel() > 6.0F;
		if (((EntityPlayerSP)player).onGround && !var3 && ((EntityPlayerSP)player).movementInput.moveForward >= var2 && !((EntityPlayerSP)player).isSprinting() && var4 && !((EntityPlayerSP)player).isUsingItem() && !((EntityPlayerSP)player).isPotionActive(Potion.blindness)) {
			if (this.sprintToggleTimer == 0) {
				this.sprintToggleTimer = 7;
			} else {
				((EntityPlayerSP)player).setSprinting(true);
				this.sprintToggleTimer = 0;
			}
		}

		if (this.sprintToggleTimer > 0) {
			--this.sprintToggleTimer;
		}

		//ここまでダッシュ関係

		if (this.flyToggleTimer > 0) {
			--this.flyToggleTimer;//入力間隔の判定タイマーのカウントを減らす．
		}

		if (player.onGround && this.isLevitation) {
			this.isLevitation = false;//地面についたら飛行から歩行へ
		}

		//飛行中の処理
		if (this.isLevitation) {

			player.motionY = 0D;//Y軸方向への移動量は入力なしでは滞空
			player.jumpMovementFactor = 0.08f;//滞空時の滞空移動速度．

			if (((EntityPlayerSP)player).movementInput.sneak) {
				player.motionY -= 0.4D;//スニークで下降．クリエイティブより少し早い
			}

			if (((EntityPlayerSP)player).movementInput.jump) {
				player.motionY += 0.4D;//Jumpキーで上昇．クリエ〈略〉
			}

		} else {
			player.jumpMovementFactor = 0.02f;//歩行時の滞空移動速度は通常と同じに
		}
	}

}